//+------------------------------------------------------------------+
//|                                                     MA_diff.mq4  |
//|                                                     Avtor: TT    |
//|                                                     Priredil: BB |
//|                                                                  |
//|This indicator is showing current price, spread                   |
//|and price difference between SMA and current price on M1          |
//|timeframe. For 9 different pairs.                                 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "TT&BB"
#property indicator_separate_window
//#property indicator_minimum 0
//#property indicator_maximum 100

//+-----------------------------------------------------------------+
//| External Parameters Set                                         |
//+-----------------------------------------------------------------+
//extern string   LabelDisplay        = "Used to Adjust Overlay";
extern int      MAperiod            = 21;
extern string   Currency1           = "GBPUSDFXF"; // must match brokers name for currency pair
extern string   Currency2           = "EURUSDFXF";
extern string   Currency3           = "AUDUSDFXF";
extern string   Currency4           = "GBPJPYFXF"; // only for 2 decimal pairs
extern string   Currency5           = "EURJPYFXF"; // only for 2 decimal pairs
extern string   Currency6           = "USDJPYFXF"; // only for 2 decimal pairs
extern string   Currency7           = "USDCADFXF";
extern string   Currency8           = "USDCHFFXF";
extern string   Currency9           = "EURGBPFXF";

color    displayColor        = LightGray;  // default color of display characters
int      displayXcord        = 10;        // Moves display left and right
int      displayYcord        = 20;        // Moves display up and down
int      displayCorner       = 0;        // 0= left up, 1= right up, 2= left down, 3= right down
int      displaySpacing      = 15;       // Changes space between lines
int      displayFontSize     = 9;        // Changes size of display characters
bool     displayOverlay      = true;     // Turns the display on and off

//+-----------------------------------------------------------------+
//| Internal Parameters Set                                         |
//+-----------------------------------------------------------------+
string   Symbolt1             = "Symbol";
string   Pricet1              = "Price BID";
string   Difft1               = "Diff SMA";
string   Spreadt1             = "Spread";
int    y;
double Curr1, Curr2, Curr3, Curr4, Curr5, Curr6, Curr7, Curr8, Curr9;
double Spread1, Spread2, Spread3, Spread4, Spread5, Spread6, Spread7, Spread8, Spread9;
double Diff1, Diff2, Diff3, Diff4, Diff5, Diff6, Diff7, Diff8, Diff9; 

//+------------------------------------------------------------------+
void init() 
  {
   Comment("");
	LabelDelete();
   
  }

//+------------------------------------------------------------------+
void deinit() 
  {
   Comment("");
	LabelDelete();   
  }

//+-----------------------------------------------------------------+
//| Create Object List Function                                     |
//+-----------------------------------------------------------------+

void Labels(){
		if(displayOverlay){
		
		   CreateLabel("Symbolt1",Symbolt1,0,displayCorner,1,0,PaleGoldenrod);
         CreateLabel("Pricet1",Pricet1,0,displayCorner,1,1,PaleGoldenrod);
         CreateLabel("Difft1",Difft1,0,displayCorner,1,3,PaleGoldenrod);
         CreateLabel("Spreadt1",Spreadt1,0,displayCorner,1,2,PaleGoldenrod);

         CreateLabel("MAL_Curr1 ",StringSubstr(Currency1,0,6),0,displayCorner,100,0);
         CreateLabel("Curr1","",0,displayCorner,100,1);
         CreateLabel("MAd1_Curr1","",0,displayCorner,100,3);
         CreateLabel("Spread_Curr1","",0,displayCorner,100,2);
         
         CreateLabel("MAL_Curr2 ",StringSubstr(Currency2,0,6),0,displayCorner,160,0);
         CreateLabel("Curr2","",0,displayCorner,160,1);
         CreateLabel("MAd1_Curr2","",0,displayCorner,160,3);
         CreateLabel("Spread_Curr2","",0,displayCorner,160,2);

         CreateLabel("MAL_Curr3 ",StringSubstr(Currency3,0,6),0,displayCorner,220,0);
         CreateLabel("Curr3","",0,displayCorner,220,1);
         CreateLabel("MAd1_Curr3","",0,displayCorner,220,3);
         CreateLabel("Spread_Curr3","",0,displayCorner,220,2);

         CreateLabel("MAL_Curr4 ",StringSubstr(Currency4,0,6),0,displayCorner,280,0);
         CreateLabel("Curr4","",0,displayCorner,280,1);
         CreateLabel("MAd1_Curr4","",0,displayCorner,280,3);
         CreateLabel("Spread_Curr4","",0,displayCorner,280,2);
         
         CreateLabel("MAL_Curr5 ",StringSubstr(Currency5,0,6),0,displayCorner,340,0);
         CreateLabel("Curr5","",0,displayCorner,340,1);
         CreateLabel("MAd1_Curr5","",0,displayCorner,340,3);
         CreateLabel("Spread_Curr5","",0,displayCorner,340,2);
        
         CreateLabel("MAL_Curr6 ",StringSubstr(Currency6,0,6),0,displayCorner,400,0);
         CreateLabel("Curr6","",0,displayCorner,400,1);
         CreateLabel("MAd1_Curr6","",0,displayCorner,400,3);
         CreateLabel("Spread_Curr6","",0,displayCorner,400,2);

         CreateLabel("MAL_Curr7 ",StringSubstr(Currency7,0,6),0,displayCorner,460,0);
         CreateLabel("Curr7","",0,displayCorner,460,1);
         CreateLabel("MAd1_Curr7","",0,displayCorner,460,3);
         CreateLabel("Spread_Curr7","",0,displayCorner,460,2);

         CreateLabel("MAL_Curr8 ",StringSubstr(Currency8,0,6),0,displayCorner,520,0);
         CreateLabel("Curr8","",0,displayCorner,520,1);
         CreateLabel("MAd1_Curr8","",0,displayCorner,520,3);
         CreateLabel("Spread_Curr8","",0,displayCorner,520,2);
         
         CreateLabel("MAL_Curr9 ",StringSubstr(Currency9,0,6),0,displayCorner,580,0);
         CreateLabel("Curr9","",0,displayCorner,580,1);
         CreateLabel("MAd1_Curr9","",0,displayCorner,580,3);
         CreateLabel("Spread_Curr9","",0,displayCorner,580,2);        

      }
}

//+------------------------------------------------------------------+
//| Delete Overlay Label Function                                    |
//+------------------------------------------------------------------+
void LabelDelete(){
		for(y=ObjectsTotal();y>=0;y--){
				if(StringSubstr(ObjectName(y),0,2)=="B3")ObjectDelete(ObjectName(y));
		}
}

//+-----------------------------------------------------------------+
//| Create Label Function (OBJ_LABEL ONLY)                          |
//+-----------------------------------------------------------------+
void CreateLabel(string Name,string Text,int FontSize,int displayCorner,int XOffset,int YLine,color Colour=CLR_NONE,string Font="Tahoma"){
		int XDistance,YDistance;
		FontSize+=displayFontSize;
		YDistance=displayYcord+displaySpacing*YLine;
		
		if(displayCorner==0)XDistance=displayXcord+XOffset;
		else if(displayCorner==1)XDistance=XOffset;
		else if(displayCorner==3){
				XDistance=XOffset;
				YDistance=YLine;
		}
		
		if(Colour==CLR_NONE) Colour=displayColor;
		
		// if(ObjectFind(Name) == -1) // 
		{
		 ObjectCreate(Name,OBJ_LABEL,WindowFind("#Scalp_indy_TT_BB"),0,0);
		 ObjectSetText(Name,Text,FontSize,Font,Colour);
		 ObjectSet(Name,OBJPROP_CORNER,displayCorner);
		 ObjectSet(Name,OBJPROP_XDISTANCE,XDistance);
		 ObjectSet(Name,OBJPROP_YDISTANCE,YDistance);
		}

}   


//+------------------------------------------------------------------+
void start()
  {
	Labels();   


//+-----------------------------------------------------------------+
//| Create MA values                                                |
//+-----------------------------------------------------------------+

      double MAv1_Curr1=  iMA(Currency1,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr2=  iMA(Currency2,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr3=  iMA(Currency3,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr4=  iMA(Currency4,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr5=  iMA(Currency5,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr6=  iMA(Currency6,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr7=  iMA(Currency7,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr8=  iMA(Currency8,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      double MAv1_Curr9=  iMA(Currency9,PERIOD_M1,MAperiod,0, MODE_SMA, PRICE_CLOSE, 0);
      
//+-----------------------------------------------------------------+
//| Create price values                                             |
//+-----------------------------------------------------------------+

      Curr1= MarketInfo(Currency1,MODE_BID);
      Curr2= MarketInfo(Currency2,MODE_BID);
      Curr3= MarketInfo(Currency3,MODE_BID);
      Curr4= MarketInfo(Currency4,MODE_BID);
      Curr5= MarketInfo(Currency5,MODE_BID);
      Curr6= MarketInfo(Currency6,MODE_BID);
      Curr7= MarketInfo(Currency7,MODE_BID);
      Curr8= MarketInfo(Currency8,MODE_BID);
      Curr9= MarketInfo(Currency9,MODE_BID);

//+-----------------------------------------------------------------+
//| Create spread values                                            |
//+-----------------------------------------------------------------+
      
      Spread1= MarketInfo(Currency1,MODE_SPREAD);
      Spread2= MarketInfo(Currency2,MODE_SPREAD);
      Spread3= MarketInfo(Currency3,MODE_SPREAD);
      Spread4= MarketInfo(Currency4,MODE_SPREAD);
      Spread5= MarketInfo(Currency5,MODE_SPREAD);
      Spread6= MarketInfo(Currency6,MODE_SPREAD);
      Spread7= MarketInfo(Currency7,MODE_SPREAD);
      Spread8= MarketInfo(Currency8,MODE_SPREAD);
      Spread9= MarketInfo(Currency9,MODE_SPREAD);
      
//+-----------------------------------------------------------------+
//| Create diff values                                              |
//+-----------------------------------------------------------------+
     
      Diff1= ((Curr1-MAv1_Curr1)*10000);
      Diff2= ((Curr2-MAv1_Curr2)*10000);
      Diff3= ((Curr3-MAv1_Curr3)*10000);
      Diff4= ((Curr4-MAv1_Curr4)*100);
      Diff5= ((Curr5-MAv1_Curr5)*100);
      Diff6= ((Curr6-MAv1_Curr6)*100);
      Diff7= ((Curr7-MAv1_Curr7)*10000);
      Diff8= ((Curr8-MAv1_Curr8)*10000);
      Diff9= ((Curr9-MAv1_Curr9)*10000);

//+-----------------------------------------------------------------+
//| Create text                                                     |
//+-----------------------------------------------------------------+

   if (Spread1>3) ObjectSetText("Spread_Curr1",DoubleToStr(Spread1,0),9,"", Red);
      else ObjectSetText("Spread_Curr1",DoubleToStr(Spread1,0));
   if (Spread2>3) ObjectSetText("Spread_Curr2",DoubleToStr(Spread2,0),9,"", Red);
      else ObjectSetText("Spread_Curr2",DoubleToStr(Spread2,0));
   if (Spread3>3) ObjectSetText("Spread_Curr3",DoubleToStr(Spread3,0),9,"", Red);
      else ObjectSetText("Spread_Curr3",DoubleToStr(Spread3,0));
   if (Spread4>3) ObjectSetText("Spread_Curr4",DoubleToStr(Spread4,0),9,"", Red);
   else ObjectSetText("Spread_Curr4",DoubleToStr(Spread4,0));
   if (Spread5>3) ObjectSetText("Spread_Curr5",DoubleToStr(Spread5,0),9,"", Red);
      else ObjectSetText("Spread_Curr5",DoubleToStr(Spread5,0));
   if (Spread6>3) ObjectSetText("Spread_Curr6",DoubleToStr(Spread6,0),9,"", Red);
      else ObjectSetText("Spread_Curr6",DoubleToStr(Spread6,0));
   if (Spread7>3) ObjectSetText("Spread_Curr7",DoubleToStr(Spread7,0),9,"", Red);
      else ObjectSetText("Spread_Curr7",DoubleToStr(Spread7,0));
   if (Spread8>3) ObjectSetText("Spread_Curr8",DoubleToStr(Spread8,0),9,"", Red);
      else ObjectSetText("Spread_Curr8",DoubleToStr(Spread8,0));
   if (Spread9>3) ObjectSetText("Spread_Curr9",DoubleToStr(Spread9,0),9,"", Red);
      else ObjectSetText("Spread_Curr9",DoubleToStr(Spread9,0));

   if (Diff1>10) ObjectSetText("Mad1_Curr1",DoubleToStr(Diff1,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr1",DoubleToStr(Diff1,0));
   if (Diff2>10) ObjectSetText("Mad1_Curr2",DoubleToStr(Diff2,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr2",DoubleToStr(Diff2,0));
   if (Diff3>10) ObjectSetText("Mad1_Curr3",DoubleToStr(Diff3,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr3",DoubleToStr(Diff3,0));
   if (Diff4>10) ObjectSetText("Mad1_Curr4",DoubleToStr(Diff4,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr4",DoubleToStr(Diff4,0));
   if (Diff5>10) ObjectSetText("Mad1_Curr5",DoubleToStr(Diff5,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr5",DoubleToStr(Diff5,0));
   if (Diff6>10) ObjectSetText("Mad1_Curr6",DoubleToStr(Diff6,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr6",DoubleToStr(Diff6,0));
   if (Diff7>10) ObjectSetText("Mad1_Curr7",DoubleToStr(Diff7,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr7",DoubleToStr(Diff7,0));
   if (Diff8>10) ObjectSetText("Mad1_Curr8",DoubleToStr(Diff8,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr8",DoubleToStr(Diff8,0));
   if (Diff9>10) ObjectSetText("Mad1_Curr9",DoubleToStr(Diff9,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr9",DoubleToStr(Diff9,0));
      
         if (Diff1<-10) ObjectSetText("Mad1_Curr1",DoubleToStr(Diff1,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr1",DoubleToStr(Diff1,0));
   if (Diff2<-10) ObjectSetText("Mad1_Curr2",DoubleToStr(Diff2,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr2",DoubleToStr(Diff2,0));
   if (Diff3<-10) ObjectSetText("Mad1_Curr3",DoubleToStr(Diff3,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr3",DoubleToStr(Diff3,0));
   if (Diff4<-10) ObjectSetText("Mad1_Curr4",DoubleToStr(Diff4,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr4",DoubleToStr(Diff4,0));
   if (Diff5<-10) ObjectSetText("Mad1_Curr5",DoubleToStr(Diff5,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr5",DoubleToStr(Diff5,0));
   if (Diff6<-10) ObjectSetText("Mad1_Curr6",DoubleToStr(Diff6,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr6",DoubleToStr(Diff6,0));
   if (Diff7<-10) ObjectSetText("Mad1_Curr7",DoubleToStr(Diff7,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr7",DoubleToStr(Diff7,0));
   if (Diff8<-10) ObjectSetText("Mad1_Curr8",DoubleToStr(Diff8,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr8",DoubleToStr(Diff8,0));
   if (Diff9<-10) ObjectSetText("Mad1_Curr9",DoubleToStr(Diff9,0),9,"", Lime);
      else ObjectSetText("Mad1_Curr9",DoubleToStr(Diff9,0));

   ObjectSetText("Curr1",DoubleToStr(Curr1,4));
   ObjectSetText("Curr2",DoubleToStr(Curr2,4));
   ObjectSetText("Curr3",DoubleToStr(Curr3,4));
   ObjectSetText("Curr4",DoubleToStr(Curr4,2));
   ObjectSetText("Curr5",DoubleToStr(Curr5,2));
   ObjectSetText("Curr6",DoubleToStr(Curr6,2));
   ObjectSetText("Curr7",DoubleToStr(Curr7,4));
   ObjectSetText("Curr8",DoubleToStr(Curr8,4));
   ObjectSetText("Curr9",DoubleToStr(Curr9,4));


}

//The End :) Happy trading.